//Modify QLS settings.
function InitWindow()
{
	this.sizeToContent();

	this.oQLSPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.qls.");
	this.QLSHostToLocale = null;

	var osbService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
   	this.oStringBundle = osbService.createBundle("chrome://qls/locale/qls.properties");

	this.oCustomLocale1 = document.getElementById('qlslocale1');
	this.oCustomLabel1 = document.getElementById('qlslabel1');
	this.oCustomLocale2 = document.getElementById('qlslocale2');
	this.oCustomLabel2 = document.getElementById('qlslabel2');
	this.oCustomLocale3 = document.getElementById('qlslocale3');
	this.oCustomLabel3 = document.getElementById('qlslabel3');
	
	this.oCustomLocale1.value = GetPref("customlocale1");
	this.oCustomLabel1.value = GetPref("customlabel1");
	this.oCustomLocale2.value = GetPref("customlocale2");
	this.oCustomLabel2.value = GetPref("customlabel2");
	this.oCustomLocale3.value = GetPref("customlocale3");
	this.oCustomLabel3.value = GetPref("customlabel3");
	
	if (GetPref("visiblemenuitems") != "")
	{
		var aMItems = GetPref("visiblemenuitems").split("#");
		var iIndex, iLen;
		
		if (aMItems && aMItems.length > 0)
		{
			iLen = aMItems.length;
			for (iIndex = 0; iIndex < iLen; iIndex ++)
			{
				document.getElementById(aMItems[iIndex]).setAttribute("checked", true);
			}
		}
	}

	this.oSwitchGULocale = document.getElementById('switch_gulocale');
	this.oSwitchGULocale.checked = GetPrefBool("switch_gulocale");
	this.oSwitchAcceptLanguages = document.getElementById('switch_accept_languages');
	this.oSwitchAcceptLanguages.checked = GetPrefBool("switch_accept_languages");
	this.oSwitchDictionary = document.getElementById('switch_dictionary');
	this.oSwitchDictionary.checked = GetPrefBool("switch_dictionary");
	this.oSwitchAlwaysAsk = document.getElementById('switch_alwaysask');
	this.oSwitchAlwaysAsk.checked = GetPrefBool("switch_alwaysask");
	DisableSwitchOptions(this.oSwitchAlwaysAsk.checked);

	this.oAskAutoRestart = document.getElementById('askautorestart');
	this.oAskAutoRestart.checked = GetPrefBool("askautorestart");

	this.oUseAutoswitch = document.getElementById('useautoswitch');
	this.oUseAutoswitch.checked = GetPrefBool("useautoswitch");

	this.oHideTools = document.getElementById('hide_tools');
	this.oHideTools.checked = GetPrefBool("hide_tools");
	this.oHideStatusbar = document.getElementById('hide_statusbar');
	this.oHideStatusbar.checked = GetPrefBool("hide_statusbar");
	
	this.oStatusBarMode = document.getElementById('statusbarmode');
	this.oStatusBarMode.value = GetPref("statusbarmode");
	DisableStatusBarMode(this.oHideStatusbar.checked);

	InitRootLocales();
	QLSInitHostLocales();
	InitAutoSwitchListbox();
}

function InitRootLocales()
{
	var oItems = document.getElementsByAttribute('rootlocale', 'true');
	var iIndex, iLen = oItems.length;
	
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (oItems[iIndex].getAttribute('haschildren') == "true") oItems[iIndex].setAttribute('label', GetString('qls.family.selectall', oItems[iIndex].getAttribute('ccode')))
	}
}

function CheckLanguageFamily(oLBItem)
{
	if (oLBItem.getAttribute('haschildren') == "true")
	{
		var oItems = document.getElementsByAttribute('ccode', oLBItem.getAttribute('ccode'));
		var iIndex, iLen = oItems.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			oItems[iIndex].checked = oLBItem.checked;
		}
	}
}

function OpenAutoSwitchHosts()
{
	window.open("chrome://qls/content/autoswitchhosts.xul", "autoswitchhosts-window", "centerscreen,chrome,width=500,height=300,resizable");
}

function ApplyAndClose()
{
	SetPref("customlocale1", this.oCustomLocale1.value);
	SetPref("customlabel1", this.oCustomLabel1.value);
	SetPref("customlocale2", this.oCustomLocale2.value);
	SetPref("customlabel2", this.oCustomLabel2.value);
	SetPref("customlocale3", this.oCustomLocale3.value);
	SetPref("customlabel3", this.oCustomLabel3.value);

	SetPrefBool("switch_gulocale", this.oSwitchGULocale.checked);
	SetPrefBool("switch_accept_languages", this.oSwitchAcceptLanguages.checked);
	SetPrefBool("switch_dictionary", this.oSwitchDictionary.checked);
	SetPrefBool("switch_alwaysask", this.oSwitchAlwaysAsk.checked);

	SetPrefBool("askautorestart", this.oAskAutoRestart.checked);
	SetPrefBool("useautoswitch", this.oUseAutoswitch.checked);

	SetPrefBool("hide_tools", this.oHideTools.checked);
	SetPrefBool("hide_statusbar", this.oHideStatusbar.checked);

	SetPref("statusbarmode", this.oStatusBarMode.value);

	var oLB = document.getElementById("lbvisiblemenuitems");
    var aItems = new Array();
	var iIndex, iLen;

	iLen = oLB.getRowCount();
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (oLB.getItemAtIndex(iIndex).getAttribute("checked") == "true") //string for some strange reason...
		{
			aItems[aItems.length] = oLB.getItemAtIndex(iIndex).getAttribute("id");
		}
	}
	if (aItems.length > 0 || ((this.oCustomLocale1.value != "" && this.oCustomLabel1.value != "") || (this.oCustomLocale2.value != "" && this.oCustomLabel2.value != "") || (this.oCustomLocale3.value != "" && this.oCustomLabel3.value != "")))
	{
		SetPref("visiblemenuitems", aItems.join("#"));

		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "qls-settings", "OK");
		window.close();
	}
}

function SelectAllItems(bSelect)
{
	var oList = document.getElementById('lbvisiblemenuitems');
	var oItem;
	var iIndex, iLen;
	
	iLen = oList.getRowCount();
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oItem = oList.getItemAtIndex(iIndex);
		oItem.setAttribute("checked", bSelect);
	}
}

function CollapseExpandAllItems(bExpand)
{
	document.getElementById('lbvisiblemenuitems').style.diplay = "none"
	var oItems = document.getElementsByAttribute('haschildren', 'true');
	var oChildren;
	var sDisplay = "-moz-grid-line";
	if (!bExpand) sDisplay = "none";
	var iIndex, iLen = oItems.length;
	var iCIndex, iCLen;
	
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oChildren = document.getElementsByAttribute('ccode', oItems[iIndex].getAttribute('ccode'));
		iCLen = oChildren.length;
		for (iCIndex = 0; iCIndex < iCLen; iCIndex ++)
		{
			if (!oChildren[iCIndex].getAttribute('haschildren'))
			{
				oChildren[iCIndex].style.display = sDisplay;
			}
		}
	
	}
	document.getElementById('lbvisiblemenuitems').style.diplay = "-moz-grid"
}

function DisableSwitchOptions(bDisable)
{
	this.oSwitchGULocale.setAttribute('disabled', bDisable);
	this.oSwitchAcceptLanguages.setAttribute('disabled', bDisable);
	this.oSwitchDictionary.setAttribute('disabled', bDisable);
}

function DisableStatusBarMode(bDisable)
{
	this.oStatusBarMode.setAttribute('disabled', bDisable);
	this.oStatusBarMode.childNodes[0].setAttribute('disabled', bDisable);
	this.oStatusBarMode.childNodes[1].setAttribute('disabled', bDisable);
	this.oStatusBarMode.childNodes[2].setAttribute('disabled', bDisable);
}

function InitAutoSwitchListbox()
{
	var oList = document.getElementById('lbitems');
	var oItem, oLItem, oCloneItem;
	var sLabel = "";
	var iIndex, iLen = this.QLSHostToLocale.length;

	RemoveListboxItems();
	
	oCloneItem = document.getElementById('liclone');
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{	
		if (this.QLSHostToLocale[iIndex][0] && this.QLSHostToLocale[iIndex][0] != "")
		{
			oItem = oCloneItem.cloneNode(true);
			oItem.setAttribute('id', 'li_' + iIndex);
			oItem.setAttribute('selected', false);
			oItem.setAttribute('current', false);
			oItem.childNodes[0].setAttribute('hostname', this.QLSHostToLocale[iIndex][0]);
			sLabel = this.QLSHostToLocale[iIndex][0];
			oLItem = document.getElementById(this.QLSHostToLocale[iIndex][1])
			if (oLItem) sLabel += " (" + oLItem.label + ")";
			else sLabel += " (" + this.QLSHostToLocale[iIndex][1] + ")";
			oItem.childNodes[0].setAttribute('label', sLabel);
			oItem.setAttribute('hidden', false);
			oList.appendChild(oItem);
		}
	}
}

function SearchVisibleMenuItems(sFilter)
{
	var oList = document.getElementById('lbvisiblemenuitems');
	var oItem;
	var iIndex, iLen = oList.childNodes.length - 1;

	sFilter	= sFilter.toLowerCase();
	for (iIndex = iLen; iIndex >= 0; iIndex --)
	{
		oItem = oList.childNodes[iIndex];
		if (oItem.nodeName == "listitem")
		{
			if (oItem.getAttribute('label').toLowerCase().indexOf(sFilter) >= 0 || sFilter == "")
			{
				oList.selectedIndex = -1;
				oList.clearSelection();
				oList.selectItem(oItem);
				oList.ensureElementIsVisible(oItem);
				return 1;
			}
		}
	}
	return 0;
}

function FilterAutoSwitchHosts(sFilter)
{
	var oList = document.getElementById('lbitems');
	var oItem;
	var iIndex, iLen = oList.childNodes.length - 1;

	sFilter	= sFilter.toLowerCase();
	for (iIndex = iLen; iIndex >= 0; iIndex --)
	{
		oItem = oList.childNodes[iIndex];
		if (oItem.nodeName == "richlistitem" && oItem.getAttribute('id') != 'liclone')
		{
			if (oItem.childNodes[0].getAttribute('label').toLowerCase().indexOf(sFilter) >= 0 || sFilter == "")
			{
				oItem.setAttribute('hidden', false);
			}
			else
			{
				oItem.setAttribute('hidden', true);
			}
		}
	}
}

function ClearAutoSwitchFilter(bApplyFilter)
{
	document.getElementById('autoswitch-filter').value = '';
	if (bApplyFilter) FilterAutoSwitchHosts('');
}

function RemoveListboxItems()
{
	var oList = document.getElementById('lbitems');
	var oItem;
	var iIndex, iLen = oList.childNodes.length - 1;
	
	for (iIndex = iLen; iIndex >= 0; iIndex --)
	{
		oItem = oList.childNodes[iIndex];
		if (oItem.nodeName == "richlistitem" && oItem.getAttribute('id') != 'liclone') oList.removeChild(oItem);
	}
}

function RemoveAutoSwitchHosts(bRemoveAll)
{
	var oList = document.getElementById('lbitems');
	var oItem;
	var sURI;
	var iIndex, iLen, iHIndex;
	
	iLen = oList.getRowCount() - 1;
	for (iIndex = iLen; iIndex > -1; iIndex --)
	{
		oItem = oList.getItemAtIndex(iIndex);
		if ((oItem.getAttribute('selected') == "true" || bRemoveAll) && (!oItem.getAttribute('hidden') || oItem.getAttribute('hidden') == "false"))
		{
			iHIndex = GetAutoSwitchIndex(oItem.childNodes[0].getAttribute('hostname'));
			if (iHIndex >= 0)
			{
				this.QLSHostToLocale.splice(iHIndex, 1);
				oList.removeChild(oItem);
			}
		}
	}
	ClearAutoSwitchFilter(false);
	QLSStoreHostLocalePref();
	QLSInitHostLocales();
	InitAutoSwitchListbox();
}

function GetAutoSwitchIndex(sHost)
{
	var iIndex, iLen = this.QLSHostToLocale.length;

	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (this.QLSHostToLocale[iIndex][0] == sHost) return iIndex;
	}
	return -1;
}

function QLSStoreHostLocalePref()
{
	var aTemp = new Array();
	var sHostLocale = "";
	var iIndex, iLen = this.QLSHostToLocale.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		aTemp[iIndex] = this.QLSHostToLocale[iIndex].join(';');
	}
	sHostLocale = aTemp.join(' ');
	SetPref("autoswitchhosts", sHostLocale);
}

function QLSInitHostLocales()
{
	this.QLSHostToLocale = null;
	this.QLSHostToLocale = new Array();
		
	var oItem;
	var aTmp = GetPref("autoswitchhosts").split(' ');
	var iIndex, iLen = aTmp.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		this.QLSHostToLocale[iIndex] = aTmp[iIndex].split(';');
	}
}

function GetPref(sName)
{
	try {return this.oQLSPref.getComplexValue(sName, Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {alert(e);}
	return this.oQLSPref.getCharPref(sName);
}

function SetPref(sName, sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oQLSPref.setComplexValue(sName, Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetPrefBool(sName)
{
	return this.oQLSPref.getBoolPref(sName);
}

function SetPrefBool(sName, bData)
{
	this.oQLSPref.setBoolPref(sName, bData);
}

function GetString(sName, sVar1, sVar2)
{
	var sResult = "";
	if(this.oStringBundle)
	{
		sResult  = this.oStringBundle.GetStringFromName(sName);
		if (sVar1) sResult = sResult.replace(/%1/g, sVar1);
		if (sVar2) sResult = sResult.replace(/%2/g, sVar2);
	}
	return sResult;
}    	

